// Dan Grossman, CSE303 Spring 2005, Lecture 22
// warning: this code compiles but has not been tested

#include <stdlib.h>
#include "lec22.h"

// clients of the filter function

int all_pred(void* env, void* obj) {
  return 1;
}

int positive_pred(void* env, void* obj) {
  return *((int*)obj) >= 0;
}

int notDivisible_pred(void* env, void* obj) {
  int i = *((int*)env);
  return *((int*)obj) % i != 0;
}

struct ListPair {
  list_t lstA;
  list_t lstB;
};
int inAnother_pred(void* env, void* obj) {
  struct ListPair * pr = (struct ListPair *)env;
  return (pr->lstA == NULL || !member(pr->lstA,obj))
    && (pr->lstB == NULL || !member(pr->lstB,obj));
}

// reverse a list
list_t reverse(list_t lst) {
  return filter(lst,NULL,all_pred);
}


// remove negative Integers; assumes all elements are int* !!
list_t positive(list_t lst) {
  return filter(lst,NULL,positive_pred);
}


// remove divisible by i; assumes all elements are int* !!
// Note: i must not be 0.
list_t notDivisibleBy(list_t lst, int i) {
  return filter(lst,&i,notDivisible_pred);
}

// remove elements of lst1 not in lst2 or lst3 (using pointer equality)
list_t unlessInAnother(list_t lst1, list_t lst2, list_t lst3) {
  struct ListPair * pr = (struct ListPair*)malloc(sizeof(struct ListPair));
  pr->lstA = lst2;
  pr->lstB = lst3;
  return filter(lst1,pr,inAnother_pred);
}

// this version okay because inAnother_pred does not free the env or
// store it somewhere for later use
list_t unlessInAnother2(list_t lst1, list_t lst2, list_t lst3) {
  struct ListPair pr;
  pr.lstA = lst2;
  pr.lstB = lst3;
  return filter(lst1,&pr,inAnother_pred);
}
