// Dan Grossman, CSE303 Spring 2005, Lecture 22
// warning: this code compiles but has not been tested

// clients of the filter function (often would be in multiple files)

class All implements Predicate {
  public boolean m(Object obj) { return true; }
}

class Positive implements Predicate {
  public boolean m(Object obj) {
    return ((Integer)obj).intValue() >= 0;
  }
}

class NotDivisible implements Predicate {
  int i;
  NotDivisible(int _i) {
    i = _i;
  }
  public boolean m(Object obj) {
    return (((Integer)obj).intValue() % i) != 0;
  }
}

class InAnother implements Predicate {
  LinkedList lstA;
  LinkedList lstB;
  InAnother(LinkedList _lstA, LinkedList _lstB) {
    lstA = _lstA;
    lstB = _lstB;
  }
  public boolean m(Object obj) {
    return (lstA == null || !lstA.member(obj)) 
      && (lstB == null || lstB.member(obj));
  }
}

class Client {
  // reverse a list
  public static LinkedList reverse(LinkedList lst) {
    return LinkedList.filter(lst,new All());
  }

  // remove negative Integers; assumes all elements are Integers!
  public static LinkedList positive(LinkedList lst) {
    return LinkedList.filter(lst,new Positive());
  }

  // remove Integers divisible by i; assumes all elements are Integers!
  // Note: i must not be 0.
  public static LinkedList notDivisibleBy(LinkedList lst, int i) {
    return LinkedList.filter(lst,new NotDivisible(i));
  }

  // remove elements of lst1 not in lst2 or lst3 (using pointer equality)
  public static LinkedList unlessInAnother(LinkedList lst1,
                                           LinkedList lst2,
                                           LinkedList lst3) {
    return LinkedList.filter(lst1,new InAnother(lst2,lst3));
  }
}
